---
title: RTCIceTransport
slug: Web/API/RTCIceTransport
tags:
  - API
  - Audio
  - Interface
  - Media
  - RTCIceTransport
  - Reference
  - Video
  - WebRTC
  - WebRTC API
  - rtc
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <code><strong>RTCIceTransport</strong></code> interface provides access to information about the {{Glossary("ICE")}} transport layer over which the data is being sent and received.</span> This is particularly useful if you need to access state information about the connection.</p>

<h2 id="Properties">Properties</h2>

<p><em>The <code>RTCIceTransport</code> interface inherits properties from its parent, {{domxref("EventTarget")}}. It also offers the following properties:</em></p>

<dl>
	<dt>{{domxref("RTCIceTransport.component", "component")}} {{ReadOnlyInline}}</dt>
	<dd>The ICE component being used by the transport. The value is one of the strings from the {{domxref("RTCIceTransport")}} enumerated type: <code>{{Glossary("RTP", '"RTP"')}}</code> or <code>"RTSP"</code>.</dd>
	<dt>{{domxref("RTCIceTransport.gatheringState", "gatheringState")}} {{ReadOnlyInline}}</dt>
	<dd>A {{domxref("DOMString")}} indicating which gathering state the ICE agent is currently in. The value is one of those included in the {{domxref("RTCIceGathererState")}} enumerated type: <code>"new"</code>, <code>"gathering"</code>, or <code>"complete"</code>.</dd>
	<dt>{{domxref("RTCIceTransport.role", "role")}} {{ReadOnlyInline}}</dt>
	<dd>Returns a {{domxref("DOMString")}} whose value is one of the members of the {{domxref("RTCIceRole")}} enumerated type: <code>"controlling"</code> or <code>"controlled"</code>; this indicates whether the ICE agent is the one that makes the final decision as to the candidate pair to use or not.</dd>
	<dt>{{domxref("RTCIceTransport.state", "state")}} {{ReadOnlyInline}}</dt>
	<dd>A {{domxref("DOMString")}} indicating what the current state of the ICE agent is. The value of <code>state</code> can be used to determine whether the ICE agent has made an initial connection using a viable candidate pair (<code>"connected"</code>), made its final selection of candidate pairs (<code>"completed"</code>), or in an error state (<code>"failed"</code>), among other states. See the {{domxref("RTCIceTransportState")}} enumerated type for a complete list of states.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Also includes methods from {{domxref("EventTarget")}}, the parent interface.</em></p>

<dl>
	<dt>{{domxref("RTCIceTransport.getLocalCandidates", "getLocalCandidates()")}}</dt>
	<dd>Returns an array of {{domxref("RTCIceCandidate")}} objects, each describing one of the ICE candidates that have been gathered so far for the local device. These are the same candidates which have already been sent to the remote peer by sending an {{event("icecandidate")}} event to the {{domxref("RTCPeerConnection")}} for transmission.</dd>
	<dt>{{domxref("RTCIceTransport.getLocalParameters", "getLocalParameters()")}}</dt>
	<dd>Returns a {{domxref("RTCIceParameters")}} object describing the ICE parameters established by a call to the {{domxref("RTCPeerConnection.setLocalDescription()")}} method. Returns <code>null</code> if parameters have not yet been received.</dd>
	<dt>{{domxref("RTCIceTransport.getRemoteCandidates", "getRemoteCandidates()")}}</dt>
	<dd>Returns an array of {{domxref("RTCIceCandidate")}} objects, one for each of the remote device's ICE candidates that have been received by the local end of the {{domxref("RTCPeerConnection")}} and delivered to ICE by calling {{domxref("RTCPeerConnection.addIceCandidate()", "addIceCandidate()")}}.</dd>
	<dt>{{domxref("RTCIceTransport.getRemoteParameters", "getRemoteParameters()")}}</dt>
	<dd>Returns a {{domxref("RTCIceParameters")}} object containing the ICE parameters for the remote device, as set by a call to {{domxref("RTCPeerConnection.setRemoteDescription()")}}. If <code>setRemoteDescription()</code> hasn't been called yet, the return value is <code>null</code>.</dd>
	<dt>{{domxref("RTCIceTransport.getSelectedCandidatePair", "getSelectedCandidatePair()")}}</dt>
	<dd>Returns a {{domxref("RTCIceCandidatePair")}} object that identifies the two candidates—one for each end of the connection—that have been selected so far. It's possible that a better pair will be found and selected later; if you need to keep up with this, watch for the {{event("selectedcandidatepairchange")}} event. If no candidate pair has been selected yet, the return value is <code>null</code>.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using {{domxref("EventTarget.addEventListener", "addEventListener()")}} or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
	<dt>{{domxref("RTCIceTransport.gatheringstatechange_event", "gatheringstatechange")}}</dt>
	<dd>Sent to the {{domxref("RTCIceTransport")}} object to indicate that the value of the {{domxref("RTCIceTransport.gatheringState", "gatheringState")}} property has changed, indicating a change in this transport's ICE candidate negotiation process.<br>
	Also available through the {{domxref("RTCIceTransport.ongatheringstatechange", "ongatheringstatechange")}} event handler property.</dd>
	<dt>{{domxref("RTCIceTransport.selectedcandidatepairchange_event", "selectedcandidatepairchange")}}</dt>
	<dd>Sent to the <code>RTCIceTransport</code> when a new, better pair of candidates has been selected to describe the connectivity between the two peers. This occurs during negotiation or renegotiation, including after an ICE restart, which reuses the existing <code>RTCIceTransport</code> objects. The current candidate pair can be obtained using {{domxref("RTCIceTransport.getSelectedCandidatePair", "getSelectedCandidatePair()")}}.<br>
	Also available using the {{domxref("RTCIceTransport.onselectedcandidatepairchange", "onselectedcandidatepairchange")}} event handler property.</dd>
	<dt>{{domxref("RTCIceTransport.statechange_event", "statechange")}}</dt>
	<dd>Sent to the <code>RTCIceTransport</code> instance when the value of the {{domxref("RTCIceTransport.state", "state")}} property has changed, indicating that the ICE gathering process has changed state.<br>
	Also available through the {{domxref("RTCIceTransport.onstatechange", "onstatechange")}} event handler property.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>tbd</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('WebRTC 1.0', '#dom-rtcicetransport', 'RTCIceTransport')}}</td>
			<td>{{Spec2('WebRTC 1.0')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceTransport")}}</p>
</div>
